import PropTypes from 'prop-types';
import cx from 'classnames';
import Icon from './Icon.js';
import LazyIcon from './LazyIcon.js';
import { BASE_CLASS, ATOM_ICON_COLORS, ATOM_ICON_SIZES, ATOM_ICON_RENDERS } from './settings.js';
import { jsx as _jsx } from "react/jsx-runtime";

var AtomIcon = function AtomIcon(_ref) {
  var _ref$as = _ref.as,
      as = _ref$as === void 0 ? 'span' : _ref$as,
      children = _ref.children,
      _ref$color = _ref.color,
      color = _ref$color === void 0 ? ATOM_ICON_COLORS.currentColor : _ref$color,
      _ref$size = _ref.size,
      size = _ref$size === void 0 ? ATOM_ICON_SIZES.small : _ref$size,
      _ref$render = _ref.render,
      render = _ref$render === void 0 ? ATOM_ICON_RENDERS.eager : _ref$render,
      title = _ref.title;
  var className = cx(BASE_CLASS, BASE_CLASS + "--" + size, color && BASE_CLASS + "--" + color);
  var IconRender = render === ATOM_ICON_RENDERS.eager ? Icon : LazyIcon;
  return /*#__PURE__*/_jsx(IconRender, {
    as: as,
    className: className,
    title: title,
    children: children
  });
};

AtomIcon.displayName = 'AtomIcon';
export default AtomIcon;
export { ATOM_ICON_COLORS, ATOM_ICON_SIZES, ATOM_ICON_RENDERS, ATOM_ICON_COLORS as atomIconColors, ATOM_ICON_SIZES as atomIconSizes, ATOM_ICON_RENDERS as atomIconRenders };